const maxRetryInterval = 5000;

const backoffFunction = async (retryInterval = 1, promise) => {
  // gets executed immediatly
  const { backoff } = await promise();

  // result contains a backoff instruction, execute the promise again after retryInterval
  if (backoff) {
    setTimeout(function() {
      backoffFunction(Math.min(maxRetryInterval, retryInterval * 2), promise);
    }, retryInterval);
  } else {
    // result had no backoff instruction, so we run again instantly
    backoffFunction(undefined, promise);
  }
};

module.exports = backoffFunction;
