const mongoose = require('mongoose');
const Schema = mongoose.Schema;

const schema = new Schema(
  {
    intent: {
      type: Schema.Types.String,
      required: true
    },
    payload: {
      type: Schema.Types.Mixed,
      default: {}
    },
    status: {
      type: Schema.Types.String,
      index: true
    },
    interval: {
      type: Schema.Types.String
    },
    time: {
      type: Schema.Types.Number,
      required: true
    },
    priority: {
      type: Schema.Types.Number,
      required: true,
      index: true
    },
    index: {
      type: Schema.Types.Number
    },
    previousEventId: {
      type: Schema.Types.ObjectId
    }
  },
  {
    minimize: false,
    timestamps: true
  }
);

module.exports = mongoose.model('Event', schema);
